diff -Naur openssl-1.0.0q.orig/crypto/asn1/asn1t.h openssl-1.0.0q/crypto/asn1/asn1t.h
--- openssl-1.0.0q.orig/crypto/asn1/asn1t.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/asn1t.h	2017-04-25 16:23:39.883530446 +0200
@@ -58,7 +58,10 @@
 #ifndef HEADER_ASN1T_H
 #define HEADER_ASN1T_H
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
+#endif /* !OPERA_SMALL_VERSION */
+
 #include <openssl/e_os2.h>
 #include <openssl/asn1.h>
 
@@ -74,6 +77,8 @@
 #endif
 
 
+#ifndef OPERA_SMALL_VERSION
+	// Normal openssl version
 #ifndef OPENSSL_EXPORT_VAR_AS_FUNCTION
 
 /* Macro to obtain ASN1_ADB pointer from a type (only used internally) */
@@ -83,7 +88,8 @@
 /* Macros for start and end of ASN1_ITEM definition */
 
 #define ASN1_ITEM_start(itname) \
-	OPENSSL_GLOBAL const ASN1_ITEM itname##_it = {
+	OPENSSL_EXTERN const ASN1_ITEM itname##_it = {
+
 
 #define ASN1_ITEM_end(itname) \
 		};
@@ -108,11 +114,29 @@
 
 #endif
 
+#define ASN1_ITEM_start1(itname) ASN1_ITEM_start(itname)
+#define ASN1_ITEM_end1(itname) ASN1_ITEM_end(itname)
 
 /* Macros to aid ASN1 template writing */
 
+#ifndef NO_ASN1_FIELD_NAMES
+#define ASN1_FIELD_NAME_FIRST(name) #name ,
+#define ASN1_FIELD_NAME_LAST(name) , #name
+#define ASN1_FIELD_NAME(name) #name
+#else
+#define ASN1_FIELD_NAME_FIRST(name)
+#define ASN1_FIELD_NAME_LAST(name)
+#define ASN1_FIELD_NAME(x)
+#endif
+
 #define ASN1_ITEM_TEMPLATE(tname) \
-	static const ASN1_TEMPLATE tname##_item_tt 
+	static const ASN1_TEMPLATE tname##_item_tt =
+
+#define ASN1_ITEM_TEMPLATE_BLOCK(tname, typ, utyp, templ, tc, fun, sz)\
+				ASN1_ITEM_start(tname) \
+					typ, utyp, templ, tc,fun, sz\
+							ASN1_FIELD_NAME_LAST(tname) \
+				ASN1_ITEM_end(itname)
 
 #define ASN1_ITEM_TEMPLATE_END(tname) \
 	;\
@@ -122,8 +146,8 @@
 		&tname##_item_tt,\
 		0,\
 		NULL,\
-		0,\
-		#tname \
+		0\
+		ASN1_FIELD_NAME_LAST(tname) \
 	ASN1_ITEM_end(tname)
 
 
@@ -150,20 +174,20 @@
  */
 
 #define ASN1_SEQUENCE(tname) \
-	static const ASN1_TEMPLATE tname##_seq_tt[] 
+	static const ASN1_TEMPLATE tname##_seq_tt[] = {
 
 #define ASN1_SEQUENCE_END(stname) ASN1_SEQUENCE_END_name(stname, stname)
 
 #define ASN1_SEQUENCE_END_name(stname, tname) \
-	;\
+	} ;\
 	ASN1_ITEM_start(tname) \
 		ASN1_ITYPE_SEQUENCE,\
 		V_ASN1_SEQUENCE,\
 		tname##_seq_tt,\
 		sizeof(tname##_seq_tt) / sizeof(ASN1_TEMPLATE),\
 		NULL,\
-		sizeof(stname),\
-		#stname \
+		sizeof(stname)\
+		ASN1_FIELD_NAME_LAST(stname) \
 	ASN1_ITEM_end(tname)
 
 #define ASN1_NDEF_SEQUENCE(tname) \
@@ -181,23 +205,23 @@
 	ASN1_SEQUENCE(tname)
 
 #define ASN1_SEQUENCE_ref(tname, cb, lck) \
-	static const ASN1_AUX tname##_aux = {NULL, ASN1_AFLG_REFCOUNT, offsetof(tname, references), lck, cb, 0}; \
+	static const ASN1_AUX tname##_aux = {NULL, ASN1_AFLG_REFCOUNT, op_offsetof(tname, references), lck, cb, 0}; \
 	ASN1_SEQUENCE(tname)
 
 #define ASN1_SEQUENCE_enc(tname, enc, cb) \
-	static const ASN1_AUX tname##_aux = {NULL, ASN1_AFLG_ENCODING, 0, 0, cb, offsetof(tname, enc)}; \
+	static const ASN1_AUX tname##_aux = {NULL, ASN1_AFLG_ENCODING, 0, 0, cb, op_offsetof(tname, enc)}; \
 	ASN1_SEQUENCE(tname)
 
 #define ASN1_NDEF_SEQUENCE_END(tname) \
-	;\
+	};\
 	ASN1_ITEM_start(tname) \
 		ASN1_ITYPE_NDEF_SEQUENCE,\
 		V_ASN1_SEQUENCE,\
 		tname##_seq_tt,\
 		sizeof(tname##_seq_tt) / sizeof(ASN1_TEMPLATE),\
 		NULL,\
-		sizeof(tname),\
-		#tname \
+		sizeof(tname)\
+		ASN1_FIELD_NAME_LAST(tname) \
 	ASN1_ITEM_end(tname)
 
 #define ASN1_BROKEN_SEQUENCE_END(stname) ASN1_SEQUENCE_END_ref(stname, stname)
@@ -206,16 +230,17 @@
 
 #define ASN1_SEQUENCE_END_cb(stname, tname) ASN1_SEQUENCE_END_ref(stname, tname)
 
+
 #define ASN1_SEQUENCE_END_ref(stname, tname) \
-	;\
+	};\
 	ASN1_ITEM_start(tname) \
 		ASN1_ITYPE_SEQUENCE,\
 		V_ASN1_SEQUENCE,\
 		tname##_seq_tt,\
 		sizeof(tname##_seq_tt) / sizeof(ASN1_TEMPLATE),\
 		&tname##_aux,\
-		sizeof(stname),\
-		#stname \
+		sizeof(stname)\
+		ASN1_FIELD_NAME_LAST(#stname) \
 	ASN1_ITEM_end(tname)
 
 #define ASN1_NDEF_SEQUENCE_END_cb(stname, tname) \
@@ -254,7 +279,7 @@
  */
 
 #define ASN1_CHOICE(tname) \
-	static const ASN1_TEMPLATE tname##_ch_tt[] 
+	static const ASN1_TEMPLATE tname##_ch_tt[] = {
 
 #define ASN1_CHOICE_cb(tname, cb) \
 	static const ASN1_AUX tname##_aux = {NULL, 0, 0, 0, cb, 0}; \
@@ -265,70 +290,96 @@
 #define ASN1_CHOICE_END_name(stname, tname) ASN1_CHOICE_END_selector(stname, tname, type)
 
 #define ASN1_CHOICE_END_selector(stname, tname, selname) \
-	;\
+	} ;\
 	ASN1_ITEM_start(tname) \
 		ASN1_ITYPE_CHOICE,\
-		offsetof(stname,selname) ,\
+		op_offsetof(stname,selname) ,\
 		tname##_ch_tt,\
 		sizeof(tname##_ch_tt) / sizeof(ASN1_TEMPLATE),\
 		NULL,\
-		sizeof(stname),\
-		#stname \
+		sizeof(stname)\
+		ASN1_FIELD_NAME_LAST(stname) \
 	ASN1_ITEM_end(tname)
 
 #define ASN1_CHOICE_END_cb(stname, tname, selname) \
-	;\
+	} ;\
 	ASN1_ITEM_start(tname) \
 		ASN1_ITYPE_CHOICE,\
-		offsetof(stname,selname) ,\
+		op_offsetof(stname,selname) ,\
 		tname##_ch_tt,\
 		sizeof(tname##_ch_tt) / sizeof(ASN1_TEMPLATE),\
 		&tname##_aux,\
-		sizeof(stname),\
-		#stname \
+		sizeof(stname)\
+		ASN1_FIELD_NAME(stname) \
 	ASN1_ITEM_end(tname)
 
 /* This helps with the template wrapper form of ASN1_ITEM */
 
 #define ASN1_EX_TEMPLATE_TYPE(flags, tag, name, type) { \
 	(flags), (tag), 0,\
-	#name, ASN1_ITEM_ref(type) }
+	ASN1_FIELD_NAME_FIRST(name)\
+	ASN1_ITEM_ref(type) }
 
 /* These help with SEQUENCE or CHOICE components */
 
 /* used to declare other types */
 
+#ifndef NO_ASN1_FIELD_NAMES
 #define ASN1_EX_TYPE(flags, tag, stname, field, type) { \
-	(flags), (tag), offsetof(stname, field),\
+	(flags), (tag), op_offsetof(stname, field),\
 	#field, ASN1_ITEM_ref(type) }
+#else
+#define ASN1_EX_TYPE(flags, tag, stname, field, type) { \
+	(flags), (tag), op_offsetof(stname, field),\
+	ASN1_ITEM_ref(type) }
+#endif
 
 /* used when the structure is combined with the parent */
 
+#ifndef NO_ASN1_FIELD_NAMES
 #define ASN1_EX_COMBINE(flags, tag, type) { \
 	(flags)|ASN1_TFLG_COMBINE, (tag), 0, NULL, ASN1_ITEM_ref(type) }
+#else
+#define ASN1_EX_COMBINE(flags, tag, type) { \
+	(flags)|ASN1_TFLG_COMBINE, (tag), 0, ASN1_ITEM_ref(type) }
+#endif
 
 /* implicit and explicit helper macros */
 
 #define ASN1_IMP_EX(stname, field, type, tag, ex) \
-		ASN1_EX_TYPE(ASN1_TFLG_IMPLICIT | ex, tag, stname, field, type)
+		ASN1_EX_TYPE(ASN1_TFLG_IMPLICIT | ex, tag, stname, field, type),
 
 #define ASN1_EXP_EX(stname, field, type, tag, ex) \
 		ASN1_EX_TYPE(ASN1_TFLG_EXPLICIT | ex, tag, stname, field, type)
+#define ASN1_EXP_EX1(stname, field, type, tag, ex) \
+		ASN1_EX_TYPE(ASN1_TFLG_EXPLICIT | ex, tag, stname, field, type)
 
 /* Any defined by macros: the field used is in the table itself */
 
 #ifndef OPENSSL_EXPORT_VAR_AS_FUNCTION
-#define ASN1_ADB_OBJECT(tblname) { ASN1_TFLG_ADB_OID, -1, 0, #tblname, (const ASN1_ITEM *)&(tblname##_adb) }
-#define ASN1_ADB_INTEGER(tblname) { ASN1_TFLG_ADB_INT, -1, 0, #tblname, (const ASN1_ITEM *)&(tblname##_adb) }
+#ifndef NO_ASN1_FIELD_NAMES
+#define ASN1_ADB_OBJECT(tblname) { ASN1_TFLG_ADB_OID, -1, 0, #tblname, (const ASN1_ITEM *)&(tblname##_adb) },
+#define ASN1_ADB_INTEGER(tblname) { ASN1_TFLG_ADB_INT, -1, 0, #tblname, (const ASN1_ITEM *)&(tblname##_adb) },
+#else
+#define ASN1_ADB_OBJECT(tblname) { ASN1_TFLG_ADB_OID, -1, 0, (const ASN1_ITEM *)&(tblname##_adb) },
+#define ASN1_ADB_INTEGER(tblname) { ASN1_TFLG_ADB_INT, -1, 0, (const ASN1_ITEM *)&(tblname##_adb) },
+#endif
 #else
-#define ASN1_ADB_OBJECT(tblname) { ASN1_TFLG_ADB_OID, -1, 0, #tblname, tblname##_adb }
-#define ASN1_ADB_INTEGER(tblname) { ASN1_TFLG_ADB_INT, -1, 0, #tblname, tblname##_adb }
+#ifndef NO_ASN1_FIELD_NAMES
+#define ASN1_ADB_OBJECT(tblname) { ASN1_TFLG_ADB_OID, -1, 0, #tblname, tblname##_adb },
+#define ASN1_ADB_INTEGER(tblname) { ASN1_TFLG_ADB_INT, -1, 0, #tblname, tblname##_adb },
+#else
+#define ASN1_ADB_OBJECT(tblname) { ASN1_TFLG_ADB_OID, -1, 0, tblname##_adb },
+#define ASN1_ADB_INTEGER(tblname) { ASN1_TFLG_ADB_INT, -1, 0, tblname##_adb },
+#endif
 #endif
 /* Plain simple type */
-#define ASN1_SIMPLE(stname, field, type) ASN1_EX_TYPE(0,0, stname, field, type)
+#define ASN1_SIMPLE(stname, field, type) ASN1_EX_TYPE(0,0, stname, field, type),
+#define ASN1_SIMPLE1(stname, field, type) ASN1_EX_TYPE(0,0, stname, field, type)
+#define ASN1_SIMPLE2(stname, field, type) ASN1_EX_TYPE(0,0, stname, field, type)
 
 /* OPTIONAL simple type */
-#define ASN1_OPT(stname, field, type) ASN1_EX_TYPE(ASN1_TFLG_OPTIONAL, 0, stname, field, type)
+#define ASN1_OPT(stname, field, type) ASN1_EX_TYPE(ASN1_TFLG_OPTIONAL, 0, stname, field, type),
 
 /* IMPLICIT tagged simple type */
 #define ASN1_IMP(stname, field, type, tag) ASN1_IMP_EX(stname, field, type, tag, 0)
@@ -338,24 +389,27 @@
 
 /* Same as above but EXPLICIT */
 
-#define ASN1_EXP(stname, field, type, tag) ASN1_EXP_EX(stname, field, type, tag, 0)
-#define ASN1_EXP_OPT(stname, field, type, tag) ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_OPTIONAL)
+#define ASN1_EXP(stname, field, type, tag) ASN1_EXP_EX(stname, field, type, tag, 0),
+#define ASN1_EXP1(stname, field, type, tag) ASN1_EXP_EX(stname, field, type, tag, 0)
+#define ASN1_EXP2(stname, field, type, tag) ASN1_EXP_EX(stname, field, type, tag, 0)
+#define ASN1_EXP_OPT(stname, field, type, tag) ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_OPTIONAL),
+#define ASN1_EXP_OPT1(stname, field, type, tag) ASN1_EXP_EX1(stname, field, type, tag, ASN1_TFLG_OPTIONAL)
 
 /* SEQUENCE OF type */
 #define ASN1_SEQUENCE_OF(stname, field, type) \
-		ASN1_EX_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, stname, field, type)
+		ASN1_EX_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, stname, field, type),
 
 /* OPTIONAL SEQUENCE OF */
 #define ASN1_SEQUENCE_OF_OPT(stname, field, type) \
-		ASN1_EX_TYPE(ASN1_TFLG_SEQUENCE_OF|ASN1_TFLG_OPTIONAL, 0, stname, field, type)
+		ASN1_EX_TYPE(ASN1_TFLG_SEQUENCE_OF|ASN1_TFLG_OPTIONAL, 0, stname, field, type),
 
 /* Same as above but for SET OF */
 
 #define ASN1_SET_OF(stname, field, type) \
-		ASN1_EX_TYPE(ASN1_TFLG_SET_OF, 0, stname, field, type)
+		ASN1_EX_TYPE(ASN1_TFLG_SET_OF, 0, stname, field, type),
 
 #define ASN1_SET_OF_OPT(stname, field, type) \
-		ASN1_EX_TYPE(ASN1_TFLG_SET_OF|ASN1_TFLG_OPTIONAL, 0, stname, field, type)
+		ASN1_EX_TYPE(ASN1_TFLG_SET_OF|ASN1_TFLG_OPTIONAL, 0, stname, field, type),
 
 /* Finally compound types of SEQUENCE, SET, IMPLICIT, EXPLICIT and OPTIONAL */
 
@@ -363,13 +417,13 @@
 			ASN1_IMP_EX(stname, field, type, tag, ASN1_TFLG_SET_OF)
 
 #define ASN1_EXP_SET_OF(stname, field, type, tag) \
-			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SET_OF)
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SET_OF),
 
 #define ASN1_IMP_SET_OF_OPT(stname, field, type, tag) \
 			ASN1_IMP_EX(stname, field, type, tag, ASN1_TFLG_SET_OF|ASN1_TFLG_OPTIONAL)
 
 #define ASN1_EXP_SET_OF_OPT(stname, field, type, tag) \
-			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SET_OF|ASN1_TFLG_OPTIONAL)
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SET_OF|ASN1_TFLG_OPTIONAL),
 
 #define ASN1_IMP_SEQUENCE_OF(stname, field, type, tag) \
 			ASN1_IMP_EX(stname, field, type, tag, ASN1_TFLG_SEQUENCE_OF)
@@ -378,10 +432,10 @@
 			ASN1_IMP_EX(stname, field, type, tag, ASN1_TFLG_SEQUENCE_OF|ASN1_TFLG_OPTIONAL)
 
 #define ASN1_EXP_SEQUENCE_OF(stname, field, type, tag) \
-			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SEQUENCE_OF)
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SEQUENCE_OF),
 
 #define ASN1_EXP_SEQUENCE_OF_OPT(stname, field, type, tag) \
-			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SEQUENCE_OF|ASN1_TFLG_OPTIONAL)
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SEQUENCE_OF|ASN1_TFLG_OPTIONAL),
 
 /* EXPLICIT using indefinite length constructed form */
 #define ASN1_NDEF_EXP(stname, field, type, tag) \
@@ -389,6 +443,10 @@
 
 /* EXPLICIT OPTIONAL using indefinite length constructed form */
 #define ASN1_NDEF_EXP_OPT(stname, field, type, tag) \
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_OPTIONAL|ASN1_TFLG_NDEF),
+#define ASN1_NDEF_EXP_OPT1(stname, field, type, tag) \
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_OPTIONAL|ASN1_TFLG_NDEF)
+#define ASN1_NDEF_EXP_OPT2(stname, field, type, tag) \
 			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_OPTIONAL|ASN1_TFLG_NDEF)
 
 /* Macros for the ASN1_ADB structure */
@@ -396,46 +454,514 @@
 #define ASN1_ADB(name) \
 	static const ASN1_ADB_TABLE name##_adbtbl[] 
 
+#define ASN1_ADB_SEQ(name) ASN1_ADB(name) = {
+
 #ifndef OPENSSL_EXPORT_VAR_AS_FUNCTION
 
 #define ASN1_ADB_END(name, flags, field, app_table, def, none) \
-	;\
+	} ;\
 	static const ASN1_ADB name##_adb = {\
 		flags,\
-		offsetof(name, field),\
+		op_offsetof(name, field),\
 		app_table,\
 		name##_adbtbl,\
 		sizeof(name##_adbtbl) / sizeof(ASN1_ADB_TABLE),\
-		def,\
+		&def,\
 		none\
-	}
+	};
 
 #else
 
 #define ASN1_ADB_END(name, flags, field, app_table, def, none) \
-	;\
+	} ;\
 	static const ASN1_ITEM *name##_adb(void) \
 	{ \
 	static const ASN1_ADB internal_adb = \
 		{\
 		flags,\
-		offsetof(name, field),\
+		op_offsetof(name, field),\
 		app_table,\
 		name##_adbtbl,\
 		sizeof(name##_adbtbl) / sizeof(ASN1_ADB_TABLE),\
-		def,\
+		&def,\
 		none\
 		}; \
 		return (const ASN1_ITEM *) &internal_adb; \
 	} \
-	void dummy_function(void)
+	void dummy_function(void);
 
 #endif
 
-#define ADB_ENTRY(val, template) {val, template}
+#define ADB_ENTRY(val, entry_template) {val, entry_template},
 
 #define ASN1_ADB_TEMPLATE(name) \
-	static const ASN1_TEMPLATE name##_tt 
+	static const ASN1_TEMPLATE name##_tt =
+
+#define ASN1_ADB_TEMPLATE_END ;
+
+#else // OPERA_SMALL_VERSION
+  // Opera specific global variable handling
+  // *******************
+#ifndef NO_ASN1_FIELD_NAMES
+#error("NO_ASN1_FIELD_NAMES must be defined")
+#endif
+#ifdef OPENSSL_EXPORT_VAR_AS_FUNCTION
+#error("OPENSSL_EXPORT_VAR_AS_FUNCTION must NOT be defined")
+#endif
+
+/* Macro to obtain ASN1_ADB pointer from a type (only used internally) */
+#define ASN1_ADB_ptr(iptr) ((const ASN1_ADB *)(iptr))
+
+
+/* Macros for start and end of ASN1_ITEM definition */
+
+#define ASN1_ITEM_start(itname) \
+	OPENSSL_PREFIX_CONST_ARRAY(OPENSSL_GLOBAL, ASN1_ITEM,itname##_it, libopeay)
+
+#define ASN1_ITEM_end(itname) \
+		CONST_END(itname)
+
+#define ASN1_ITEM_start1(itname) \
+	OPENSSL_PREFIX_CONST_ITEM(OPENSSL_GLOBAL, ASN1_ITEM,itname##_it, libopeay)
+
+#define ASN1_ITEM_end1(itname)
+
+#define ASN1_ITEM_DECLARE(itname) DECLARE_MODULE_CONST_ITEM(ASN1_ITEM,itname##_it)
+
+/* Macros to aid ASN1 template writing */
+
+#define ASN1_FIELD_NAME_FIRST(name)
+#define ASN1_FIELD_NAME_LAST(name)
+#define ASN1_FIELD_NAME(x)
+
+#define CONST_ENTRY_TEMPLATE_ITEM(flg, tg, off, ref)\
+		CONST_ENTRY_START(flags, flg)\
+		CONST_ENTRY_SINGLE(tag, tg)\
+		CONST_ENTRY_SINGLE(offset, off)\
+		CONST_ENTRY_SINGLE(item, ref)\
+		CONST_ENTRY_END
+
+#define CONST_ENTRY_TEMPLATE_ITEM1(flg, tg, off, ref)\
+		CONST_ITEM_ENTRY_START(flags, flg)\
+		CONST_ITEM_ENTRY_SINGLE(tag, tg)\
+		CONST_ITEM_ENTRY_SINGLE(offset, off)\
+		CONST_ITEM_ENTRY_SINGLE(item, ref)\
+		CONST_ITEM_ENTRY_END
+
+#define CONST_ENTRY_SINGLE_ASN1_ITEM(typ, utyp, templ, tc, fun, sz)\
+		CONST_ITEM_ENTRY_START(itype,typ)\
+		CONST_ITEM_ENTRY_SINGLE(utype,utyp)\
+		CONST_ITEM_ENTRY_SINGLE(templates,templ)\
+		CONST_ITEM_ENTRY_SINGLE(tcount,tc)\
+		CONST_ITEM_ENTRY_SINGLE(funcs,fun)\
+		CONST_ITEM_ENTRY_SINGLE(size,sz)\
+		CONST_ITEM_ENTRY_END
+
+
+#define ASN1_ITEM_TEMPLATE(tname) \
+	OPENSSL_PREFIX_CONST_ITEM(static, ASN1_TEMPLATE, tname##_item_tt, libopeay)
+
+#define ASN1_ITEM_TEMPLATE_BLOCK(tname, typ, utyp, templ, tc, fun, sz)\
+	ASN1_ITEM_start1(tname) \
+		CONST_ENTRY_SINGLE_ASN1_ITEM(typ, utyp, templ, tc, fun, sz)\
+	ASN1_ITEM_end1(tname)
+
+
+#define ASN1_ITEM_TEMPLATE_END(tname) \
+	ASN1_ITEM_TEMPLATE_BLOCK(tname ,ASN1_ITYPE_PRIMITIVE, -1 ,&OPENSSL_GLOBAL_NAME_item_tt(tname),0,NULL,0)
+
+#define ASN1_TYPE_TEMPLATE_DECLARE(tname)\
+	ASN1_ITEM_DECLARE(tname)
+
+#define ASN1_TYPE_TEMPLATE_DECLARE_FUN_C(tname)\
+	ASN1_ITEM_DECLARE_FUN_C(tname)
+
+#define ASN1_ITEM_TEMPLATE_DECLARE(tname)\
+	DECLARE_MODULE_CONST_ITEM(ASN1_TEMPLATE, tname##_item_tt);\
+	ASN1_ITEM_DECLARE(tname)
+
+/* This is a ASN1 type which just embeds a template */
+
+/* This pair helps declare a SEQUENCE. We can do:
+ *
+ * 	ASN1_SEQUENCE(stname) = {
+ * 		... SEQUENCE components ...
+ * 	} ASN1_SEQUENCE_END(stname)
+ *
+ * 	This will produce an ASN1_ITEM called stname_it
+ *	for a structure called stname.
+ *
+ * 	If you want the same structure but a different
+ *	name then use:
+ *
+ * 	ASN1_SEQUENCE(itname) = {
+ * 		... SEQUENCE components ...
+ * 	} ASN1_SEQUENCE_END_name(stname, itname)
+ *
+ *	This will create an item called itname_it using
+ *	a structure called stname.
+ */
+
+#define ASN1_SEQUENCE(tname) \
+	OPENSSL_PREFIX_CONST_ARRAY(static, ASN1_TEMPLATE, tname##_seq_tt, libopeay)
+
+#define ASN1_SEQUENCE_END(stname) ASN1_SEQUENCE_END_name(stname, stname)
+
+#define ASN1_SEQUENCE_END_name(stname,tname) \
+	CONST_END(tname##_seq_tt)\
+	ASN1_ITEM_TEMPLATE_BLOCK(tname,ASN1_ITYPE_SEQUENCE,V_ASN1_SEQUENCE,OPENSSL_GLOBAL_ARRAY_NAME(tname##_seq_tt), \
+					OPENSSL_CONST_ARRAY_SIZE(tname##_seq_tt), NULL, sizeof(stname))
+
+#define ASN1_SEQUENCE_DECLARE(tname)\
+	DECLARE_MODULE_CONST_ARRAY(ASN1_TEMPLATE,tname##_seq_tt);\
+	ASN1_ITEM_DECLARE(tname)
+
+#define ASN1_NDEF_SEQUENCE(tname) \
+	ASN1_SEQUENCE(tname)
+
+#define ASN1_NDEF_SEQUENCE_cb(tname, cb) \
+	ASN1_SEQUENCE_cb(tname, cb)
+
+#define CONST_ASN1_AUX(name, ad, f, ro, rl, cb, eo) \
+	OPENSSL_PREFIX_CONST_ITEM(static, ASN1_AUX, name, libopeay) \
+		CONST_ITEM_ENTRY_START(app_data,ad)\
+		CONST_ITEM_ENTRY_SINGLE(flags,f)\
+		CONST_ITEM_ENTRY_SINGLE(ref_offset,ro)\
+		CONST_ITEM_ENTRY_SINGLE(ref_lock,rl)\
+		CONST_ITEM_ENTRY_SINGLE(asn1_cb,cb)\
+		CONST_ITEM_ENTRY_SINGLE(enc_offset,eo)\
+		CONST_ITEM_ENTRY_END
+
+#define ASN1_AUX_DECLARE(tname)\
+	DECLARE_MODULE_CONST_ITEM(ASN1_AUX, tname)
+
+
+#define ASN1_SEQUENCE_cb(tname, cb) \
+	CONST_ASN1_AUX(tname##_aux, NULL, 0, 0, 0, cb, 0) \
+	ASN1_SEQUENCE(tname)
+
+#define ASN1_BROKEN_SEQUENCE(tname) \
+	CONST_ASN1_AUX(tname##_aux, NULL, ASN1_AFLG_BROKEN, 0, 0, 0, 0) \
+	ASN1_SEQUENCE(tname)
+
+#define ASN1_SEQUENCE_ref(tname, cb, lck) \
+	CONST_ASN1_AUX(tname##_aux, NULL, ASN1_AFLG_REFCOUNT, op_offsetof(tname, references), lck, cb, 0) \
+	ASN1_SEQUENCE(tname)
+
+#define ASN1_SEQUENCE_enc(tname, enc, cb) \
+	CONST_ASN1_AUX(tname##_aux, NULL, ASN1_AFLG_ENCODING, 0, 0, cb, op_offsetof(tname, enc)) \
+	ASN1_SEQUENCE(tname)
+
+#define ASN1_SEQ_AUX_DECLARE(tname)\
+	ASN1_AUX_DECLARE(tname##_aux);\
+	ASN1_SEQUENCE_DECLARE(tname)
+
+#define ASN1_SEQ_AUX_DECLARE_FUN_C(tname)\
+	ASN1_AUX_DECLARE_FUN_C(tname##_aux);\
+	ASN1_SEQUENCE_DECLARE_FUN_C(tname)
+
+
+#define ASN1_NDEF_SEQUENCE_END(tname) \
+	CONST_END(tname)\
+	ASN1_ITEM_TEMPLATE_BLOCK(tname,ASN1_ITYPE_NDEF_SEQUENCE, V_ASN1_SEQUENCE, OPENSSL_GLOBAL_ARRAY_NAME(tname##_seq_tt),\
+		OPENSSL_CONST_ARRAY_SIZE(tname##_seq_tt), NULL, sizeof(tname))
+
+#define ASN1_BROKEN_SEQUENCE_END(stname) ASN1_SEQUENCE_END_ref(stname, stname)
+
+#define ASN1_SEQUENCE_END_enc(stname, tname) ASN1_SEQUENCE_END_ref(stname, tname)
+
+#define ASN1_SEQUENCE_END_cb(stname, tname) ASN1_SEQUENCE_END_ref(stname, tname)
+
+#define ASN1_SEQUENCE_END_ref(stname, tname) \
+	CONST_END(stname)\
+	ASN1_ITEM_TEMPLATE_BLOCK(tname,ASN1_ITYPE_SEQUENCE,V_ASN1_SEQUENCE,OPENSSL_GLOBAL_ARRAY_NAME(tname##_seq_tt),\
+		OPENSSL_CONST_ARRAY_SIZE(tname##_seq_tt),\
+		&OPENSSL_GLOBAL_ITEM_NAME(tname##_aux),\
+		sizeof(stname))
+
+#define ASN1_NDEF_SEQUENCE_END_cb(stname, tname) \
+	CONST_END(stname)\
+	ASN1_ITEM_TEMPLATE_BLOCK(tname,ASN1_ITYPE_SEQUENCE,V_ASN1_SEQUENCE,OPENSSL_GLOBAL_ARRAY_NAME(tname##_seq_tt),\
+		OPENSSL_CONST_ARRAY_SIZE(tname##_seq_tt),\
+		&OPENSSL_GLOBAL_ITEM_NAME(tname##_aux),\
+		sizeof(stname))
+
+
+/* This pair helps declare a CHOICE type. We can do:
+ *
+ * 	ASN1_CHOICE(chname) = {
+ * 		... CHOICE options ...
+ * 	ASN1_CHOICE_END(chname)
+ *
+ * 	This will produce an ASN1_ITEM called chname_it
+ *	for a structure called chname. The structure
+ *	definition must look like this:
+ *	typedef struct {
+ *		int type;
+ *		union {
+ *			ASN1_SOMETHING *opt1;
+ *			ASN1_SOMEOTHER *opt2;
+ *		} value;
+ *	} chname;
+ *
+ *	the name of the selector must be 'type'.
+ * 	to use an alternative selector name use the
+ *      ASN1_CHOICE_END_selector() version.
+ */
+
+#define ASN1_CHOICE(tname) \
+	OPENSSL_PREFIX_CONST_ARRAY(static, ASN1_TEMPLATE, tname##_ch_tt, libopeay)
+
+#define ASN1_CHOICE_cb(tname, cb) \
+	CONST_ASN1_AUX(tname##_aux, NULL, 0, 0, 0, cb, 0) \
+	ASN1_CHOICE(tname)
+
+#define ASN1_CHOICE_END(stname) ASN1_CHOICE_END_name(stname, stname)
+
+#define ASN1_CHOICE_END_name(stname, tname) ASN1_CHOICE_END_selector(stname, tname, type)
+
+#define ASN1_CHOICE_END_selector(stname, tname, selname) \
+	CONST_END(stname)\
+	ASN1_ITEM_TEMPLATE_BLOCK(tname,\
+		ASN1_ITYPE_CHOICE,\
+		op_offsetof(stname,selname) ,\
+		OPENSSL_GLOBAL_ARRAY_NAME(tname##_ch_tt),\
+		OPENSSL_CONST_ARRAY_SIZE(tname##_ch_tt),\
+		NULL,\
+		sizeof(stname))
+
+#define ASN1_CHOICE_END_cb(stname, tname, selname) \
+	CONST_END(stname)\
+	ASN1_ITEM_TEMPLATE_BLOCK(tname, \
+		ASN1_ITYPE_CHOICE,\
+		op_offsetof(stname,selname) ,\
+		OPENSSL_GLOBAL_ARRAY_NAME(tname##_ch_tt),\
+		OPENSSL_CONST_ARRAY_SIZE(tname##_ch_tt),\
+		&OPENSSL_GLOBAL_ITEM_NAME(tname##_aux),\
+		sizeof(stname))
+
+#define ASN1_CHOICE_DECLARE(tname)\
+	DECLARE_MODULE_CONST_ARRAY(ASN1_TEMPLATE, tname##_ch_tt);\
+	ASN1_ITEM_DECLARE(tname)
+
+#define ASN1_CHOICE_cb_DECLARE(tname)\
+	ASN1_AUX_DECLARE(tname##_aux);\
+	ASN1_CHOICE_DECLARE(tname)
+
+#define ASN1_CHOICE_cb_DECLARE_FUN_C(tname)\
+	ASN1_AUX_DECLARE_FUN_C(tname##_aux);\
+	ASN1_CHOICE_DECLARE_FUN_C(tname)
+
+/* This helps with the template wrapper form of ASN1_ITEM */
+
+#define ASN1_EX_TEMPLATE_TYPE(flags, tag, name, type) \
+	CONST_ENTRY_TEMPLATE_ITEM1( (flags), (tag), 0,\
+		ASN1_ITEM_ref(type))
+
+/* These help with SEQUENCE or CHOICE components */
+
+/* used to declare other types */
+
+#define ASN1_EX_TYPE(flags, tag, stname, field, type) \
+	CONST_ENTRY_TEMPLATE_ITEM((flags), (tag), op_offsetof(stname, field),\
+	ASN1_ITEM_ref(type) )
+#define ASN1_EX_TYPE1(flags, tag, stname, field, type) \
+	CONST_ENTRY_TEMPLATE_ITEM1((flags), (tag), op_offsetof(stname, field),\
+	ASN1_ITEM_ref(type) )
+
+/* used when the structure is combined with the parent */
+
+#define ASN1_EX_COMBINE(flags, tag, type) \
+	CONST_ENTRY_TEMPLATE_ITEM((flags)|ASN1_TFLG_COMBINE, (tag), 0, ASN1_ITEM_ref(type) )
+
+/* implicit and explicit helper macros */
+
+#define ASN1_IMP_EX(stname, field, type, tag, ex) \
+		ASN1_EX_TYPE(ASN1_TFLG_IMPLICIT | ex, tag, stname, field, type)
+
+#define ASN1_EXP_EX(stname, field, type, tag, ex) \
+		ASN1_EX_TYPE(ASN1_TFLG_EXPLICIT | ex, tag, stname, field, type)
+#define ASN1_EXP_EX1(stname, field, type, tag, ex) \
+		ASN1_EX_TYPE1(ASN1_TFLG_EXPLICIT | ex, tag, stname, field, type)
+
+/* Any defined by macros: the field used is in the table itself */
+
+#define ASN1_ADB_OBJECT(tblname) CONST_ENTRY_TEMPLATE_ITEM( ASN1_TFLG_ADB_OID, -1, 0, (const ASN1_ITEM *)&(OPENSSL_GLOBAL_ITEM_NAME(tblname##_adb)) )
+#define ASN1_ADB_INTEGER(tblname) CONST_ENTRY_TEMPLATE_ITEM( ASN1_TFLG_ADB_INT, -1, 0, (const ASN1_ITEM *)&(OPENSSL_GLOBAL_ITEM_NAME(tblname##_adb)) )
+
+/* Plain simple type */
+#define ASN1_SIMPLE(stname, field, type) ASN1_EX_TYPE(0,0, stname, field, type)
+#define ASN1_SIMPLE1(stname, field, type) ASN1_EX_TYPE1(0,0, stname, field, type)
+// Inside ADB_ENTRY
+#ifdef HAS_COMPLEX_GLOBALS
+#define ASN1_SIMPLE2(stname, field, type) \
+		CONST_ENTRY_START(tt.flags, 0)  \
+		CONST_ENTRY_SINGLE(tt.tag, 0)  \
+		CONST_ENTRY_SINGLE(tt.offset, op_offsetof(stname, field))\
+		CONST_ENTRY_SINGLE(tt.item, ASN1_ITEM_ref(type)) \
+		CONST_ITEM_ENTRY_END2
+#else
+#define ASN1_SIMPLE2(stname, field, type) \
+		CONST_ENTRY_SINGLE(tt.flags, 0)\
+		CONST_ENTRY_SINGLE(tt.tag, 0)\
+		CONST_ENTRY_SINGLE(tt.offset, op_offsetof(stname, field))\
+		CONST_ENTRY_SINGLE(tt.item, ASN1_ITEM_ref(type))
+#endif
+
+/* OPTIONAL simple type */
+#define ASN1_OPT(stname, field, type) ASN1_EX_TYPE(ASN1_TFLG_OPTIONAL, 0, stname, field, type)
+
+/* IMPLICIT tagged simple type */
+#define ASN1_IMP(stname, field, type, tag) ASN1_IMP_EX(stname, field, type, tag, 0)
+
+/* IMPLICIT tagged OPTIONAL simple type */
+#define ASN1_IMP_OPT(stname, field, type, tag) ASN1_IMP_EX(stname, field, type, tag, ASN1_TFLG_OPTIONAL)
+
+/* Same as above but EXPLICIT */
+
+#define ASN1_EXP(stname, field, type, tag) ASN1_EXP_EX(stname, field, type, tag, 0)
+#define ASN1_EXP1(stname, field, type, tag) ASN1_EXP_EX1(stname, field, type, tag, 0)
+
+#ifdef HAS_COMPLEX_GLOBALS
+#define ASN1_EXP2(stname, field, type, _tag) \
+		CONST_ENTRY_START(tt.flags, ASN1_TFLG_EXPLICIT)\
+		CONST_ENTRY_SINGLE(tt.tag, _tag)\
+		CONST_ENTRY_SINGLE(tt.offset, op_offsetof(stname, field))\
+		CONST_ENTRY_SINGLE(tt.item, ASN1_ITEM_ref(type))\
+		CONST_ITEM_ENTRY_END2
+#else
+// Inside ADB_ENTRY
+#define ASN1_EXP2(stname, field, type, _tag) \
+		CONST_ENTRY_SINGLE(tt.flags, ASN1_TFLG_EXPLICIT)\
+		CONST_ENTRY_SINGLE(tt.tag, _tag)\
+		CONST_ENTRY_SINGLE(tt.offset, op_offsetof(stname, field))\
+		CONST_ENTRY_SINGLE(tt.item, ASN1_ITEM_ref(type))
+#endif
+
+#define ASN1_EXP_OPT(stname, field, type, tag) ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_OPTIONAL)
+#define ASN1_EXP_OPT1(stname, field, type, tag) ASN1_EXP_EX1(stname, field, type, tag, ASN1_TFLG_OPTIONAL)
+
+/* SEQUENCE OF type */
+#define ASN1_SEQUENCE_OF(stname, field, type) \
+		ASN1_EX_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, stname, field, type)
+
+/* OPTIONAL SEQUENCE OF */
+#define ASN1_SEQUENCE_OF_OPT(stname, field, type) \
+		ASN1_EX_TYPE(ASN1_TFLG_SEQUENCE_OF|ASN1_TFLG_OPTIONAL, 0, stname, field, type)
+
+/* Same as above but for SET OF */
+
+#define ASN1_SET_OF(stname, field, type) \
+		ASN1_EX_TYPE(ASN1_TFLG_SET_OF, 0, stname, field, type)
+
+#define ASN1_SET_OF_OPT(stname, field, type) \
+		ASN1_EX_TYPE(ASN1_TFLG_SET_OF|ASN1_TFLG_OPTIONAL, 0, stname, field, type)
+
+/* Finally compound types of SEQUENCE, SET, IMPLICIT, EXPLICIT and OPTIONAL */
+
+#define ASN1_IMP_SET_OF(stname, field, type, tag) \
+			ASN1_IMP_EX(stname, field, type, tag, ASN1_TFLG_SET_OF)
+
+#define ASN1_EXP_SET_OF(stname, field, type, tag) \
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SET_OF)
+
+#ifdef HAS_COMPLEX_GLOBALS
+#define ASN1_EXP_SET_OF2(stname, field, type, _tag) \
+		CONST_ENTRY_START(tt.flags, ASN1_TFLG_EXPLICIT | ASN1_TFLG_SET_OF)\
+		CONST_ENTRY_SINGLE(tt.tag, _tag)\
+		CONST_ENTRY_SINGLE(tt.offset, op_offsetof(stname, field))\
+		CONST_ENTRY_SINGLE(tt.item, ASN1_ITEM_ref(type))\
+		CONST_ITEM_ENTRY_END2
+#else
+// Inside ADB_ENTRY
+#define ASN1_EXP_SET_OF2(stname, field, type, _tag) \
+		CONST_ENTRY_SINGLE(tt.flags, ASN1_TFLG_EXPLICIT | ASN1_TFLG_SET_OF)\
+		CONST_ENTRY_SINGLE(tt.tag, _tag)\
+		CONST_ENTRY_SINGLE(tt.offset, op_offsetof(stname, field))\
+		CONST_ENTRY_SINGLE(tt.item, ASN1_ITEM_ref(type))
+#endif
+
+#define ASN1_IMP_SET_OF_OPT(stname, field, type, tag) \
+			ASN1_IMP_EX(stname, field, type, tag, ASN1_TFLG_SET_OF|ASN1_TFLG_OPTIONAL)
+
+#define ASN1_EXP_SET_OF_OPT(stname, field, type, tag) \
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SET_OF|ASN1_TFLG_OPTIONAL)
+
+#define ASN1_IMP_SEQUENCE_OF(stname, field, type, tag) \
+			ASN1_IMP_EX(stname, field, type, tag, ASN1_TFLG_SEQUENCE_OF)
+
+#define ASN1_IMP_SEQUENCE_OF_OPT(stname, field, type, tag) \
+			ASN1_IMP_EX(stname, field, type, tag, ASN1_TFLG_SEQUENCE_OF|ASN1_TFLG_OPTIONAL)
+
+#define ASN1_EXP_SEQUENCE_OF(stname, field, type, tag) \
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SEQUENCE_OF)
+
+#define ASN1_EXP_SEQUENCE_OF_OPT(stname, field, type, tag) \
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_SEQUENCE_OF|ASN1_TFLG_OPTIONAL)
+
+/* EXPLICIT OPTIONAL using indefinite length constructed form */
+#define ASN1_NDEF_EXP_OPT(stname, field, type, tag) \
+			ASN1_EXP_EX(stname, field, type, tag, ASN1_TFLG_OPTIONAL|ASN1_TFLG_NDEF)
+#define ASN1_NDEF_EXP_OPT1(stname, field, type, tag) \
+			ASN1_EXP_EX1(stname, field, type, tag, ASN1_TFLG_OPTIONAL|ASN1_TFLG_NDEF)
+
+#ifdef HAS_COMPLEX_GLOBALS
+#define ASN1_NDEF_EXP_OPT2(stname, field, type, _tag) \
+		CONST_ENTRY_START(tt.flags, (ASN1_TFLG_EXPLICIT | ASN1_TFLG_OPTIONAL|ASN1_TFLG_NDEF))\
+		CONST_ENTRY_SINGLE(tt.tag, (_tag))\
+		CONST_ENTRY_SINGLE(tt.offset, op_offsetof(stname, field))\
+		CONST_ENTRY_SINGLE(tt.item, ASN1_ITEM_ref(type))\
+		CONST_ITEM_ENTRY_END2
+#else
+// Inside ADB_ENTRY
+#define ASN1_NDEF_EXP_OPT2(stname, field, type, _tag) \
+		CONST_ENTRY_SINGLE(tt.flags, (ASN1_TFLG_EXPLICIT | ASN1_TFLG_OPTIONAL|ASN1_TFLG_NDEF))\
+		CONST_ENTRY_SINGLE(tt.tag, (_tag))\
+		CONST_ENTRY_SINGLE(tt.offset, op_offsetof(stname, field))\
+		CONST_ENTRY_SINGLE(tt.item, ASN1_ITEM_ref(type))
+#endif
+
+/* Macros for the ASN1_ADB structure */
+
+#define ASN1_ADB(name) \
+	OPENSSL_PREFIX_CONST_ARRAY(static, ASN1_ADB_TABLE, name##_adbtbl, libopeay) 
+
+#define ASN1_ADB_SEQ(name) ASN1_ADB(name)
+
+#define ASN1_ADB_END(name, _flags, field, app_table, def, none) \
+	CONST_END(name##_adbtbl) \
+	OPENSSL_PREFIX_CONST_ITEM(static, ASN1_ADB, name##_adb, libopeay)\
+		CONST_ITEM_ENTRY_START(flags, _flags)\
+		CONST_ITEM_ENTRY_SINGLE(offset, op_offsetof(name, field))\
+		CONST_ITEM_ENTRY_SINGLE(app_items, app_table)\
+		CONST_ITEM_ENTRY_SINGLE(tbl, OPENSSL_GLOBAL_ARRAY_NAME(name##_adbtbl))\
+		CONST_ITEM_ENTRY_SINGLE(tblcount, OPENSSL_CONST_ARRAY_SIZE(name##_adbtbl))\
+		CONST_ITEM_ENTRY_SINGLE(default_tt, &OPENSSL_GLOBAL_ITEM_NAME(def))\
+		CONST_ITEM_ENTRY_SINGLE(null_tt, none)\
+		CONST_ITEM_ENTRY_END
+
+#define ADB_ENTRY(val, entry_template)\
+	CONST_ENTRY_START(value, val)\
+	CONST_ENTRY_SEP	\
+	entry_template  \
+	CONST_ENTRY_END
+
+#define ASN1_ADB_SEQ_DECLARE(tname)\
+	DECLARE_MODULE_CONST_ARRAY(ASN1_ADB_TABLE, tname##_adbtbl);\
+	DECLARE_MODULE_CONST_ITEM(ASN1_ADB, tname##_adb)
+
+#define ASN1_ADB_TEMPLATE(name) \
+	OPENSSL_PREFIX_CONST_ITEM(static, ASN1_TEMPLATE, name##_tt, libopeay)
+
+#define ASN1_ADB_TEMPLATE_END
+
+#define ASN1_ADB_TEMPLATE_DECLARE(tname)\
+	DECLARE_MODULE_CONST_ITEM(ASN1_TEMPLATE, tname##_tt)
+
+
+  // *******************
+  // End of Opera specific handling
+#endif //OPERA_SMALL_VERSION
 
 /* This is the ASN1 template structure that defines
  * a wrapper round the actual type. It determines the
@@ -473,7 +999,7 @@
 
 struct ASN1_ADB_TABLE_st {
 	long value;		/* NID for an object or value for an int */
-	const ASN1_TEMPLATE tt;		/* item for this value */
+	ASN1_TEMPLATE tt;		/* item for this value */
 };
 
 /* template flags */
@@ -774,15 +1300,14 @@
 /* Macro to implement a primitive type */
 #define IMPLEMENT_ASN1_TYPE(stname) IMPLEMENT_ASN1_TYPE_ex(stname, stname, 0)
 #define IMPLEMENT_ASN1_TYPE_ex(itname, vname, ex) \
-				ASN1_ITEM_start(itname) \
-					ASN1_ITYPE_PRIMITIVE, V_##vname, NULL, 0, NULL, ex, #itname \
-				ASN1_ITEM_end(itname)
+				ASN1_ITEM_TEMPLATE_BLOCK(itname, \
+					ASN1_ITYPE_PRIMITIVE, V_##vname , NULL, 0, NULL, ex)
 
 /* Macro to implement a multi string type */
 #define IMPLEMENT_ASN1_MSTRING(itname, mask) \
-				ASN1_ITEM_start(itname) \
-					ASN1_ITYPE_MSTRING, mask, NULL, 0, NULL, sizeof(ASN1_STRING), #itname \
-				ASN1_ITEM_end(itname)
+				ASN1_ITEM_TEMPLATE_BLOCK(itname, \
+					ASN1_ITYPE_MSTRING, mask, NULL, 0, NULL, sizeof(ASN1_STRING)\
+						ASN1_FIELD_NAME_LAST(itname))
 
 /* Macro to implement an ASN1_ITEM in terms of old style funcs */
 
